#include <stdio.h>
#include <stdlib.h>

#define UC unsigned char
#define UI unsigned long int
#define US unsigned short int

#define HASHSIZE (4*1024*1024)

UI rands[256];

int sx,sy; /* velikosti*/
UC pole[200][201];
UC poleused[200][200];
UI curhash[22];

int wordcnt;
UC word[1000][21];
int wordlen[1000];
UI wordhash[1000];

US *bl;
UC *bx;
UC *by;
UC *bd;
UC *bs;

int dx[8]={0,1,1,1,0,-1,-1,-1};
int dy[8]={-1,-1,0,1,1,1,0,-1};

void delword(int stx,int sty,int dir,int len)
{
 int t;
 int cx,cy;
 
 for(t=0;t<len;t++)
  {
  cx=(stx+t*dx[dir]+100*sx)%sx;
  cy=(sty+t*dy[dir]+100*sy)%sy;
  poleused[cy][cx]=1;
  }

}

void add2hash(UI hash, int x,int y,int d,int s)
{
 UI hashslot;
 int cnt=0;
 
 hashslot=(hash>>10)&(HASHSIZE-1);
 while(bd[hashslot]!=9) {hashslot++;hashslot&=(HASHSIZE-1);cnt++;if(cnt>=7) break;}
 bl[hashslot]=(US)hash;
 bx[hashslot]=x;
 by[hashslot]=y;
 bd[hashslot]=d;
 bs[hashslot]=s;
}

int rethash(UI hash, int *x,int *y,int *d,int *s)
{
 UI hashslot;
 hashslot=(hash>>10)&(HASHSIZE-1);
again: 
 if(bd[hashslot]==9) return 0;
 if(bl[hashslot]!=(US)hash) {hashslot++;hashslot&=(HASHSIZE-1);goto again;}
 *x=bx[hashslot];
 *y=by[hashslot];
 *d=bd[hashslot];
 *s=bs[hashslot];
 return 1;
}

void gethashes()
{
 int x,y,t,i;
 int cx,cy;
 UC c;
 UI hash;
 
 for(y=0;y<sy;y++)
  for(x=0;x<sx;x++)
   {
   for(t=0;t<8;t++) 
    { 
    hash=0;
    for(i=0;i<21;i++) 
     { 
     cx=(x+i*dx[t]+100*sx)%sx;
     cy=(y+i*dy[t]+100*sy)%sy;
     c=pole[cy][cx];
     hash+=rands[c];
     hash=(hash<<7)+(hash>>23);
     hash+=123;
     curhash[i+1]=hash;
     add2hash(hash,x,y,t,i+1);
     }
    /*for(i=0;i<wordcnt;i++)
     {
     hash2=curhash[wordlen[i]];
     if(wordhash[i]==hash2) delword(x,y,t,wordlen[i]);
     }*/ 
    }
   }
}

void printresult()
{
 int x,y;
 
 for(y=0;y<sy;y++)
  {
  for(x=0;x<sx;x++)
   {
   if(poleused[y][x]==1) continue;
   printf("%c",pole[y][x]);
   }
  } 
  printf("\n"); 
}

void getwordhashes()
{
 int t,i,f;
 UI hash;
 UC c;
 int hx,hy,hd,hs;
 
 for(t=0;t<wordcnt;t++)
  {
  hash=0;
  for(i=0;i<wordlen[t];i++)
   {
   c=word[t][i];
   hash+=rands[c];
   hash=(hash<<7)+(hash>>23);
   hash+=123;
   }
  f=rethash(hash,&hx,&hy,&hd,&hs);
  if(f) delword(hx,hy,hd,hs);
  /*wordhash[t]=hash; */
  /*printf("%s = %08x\n",word[t],wordhash[t]);*/
  }
}

void solve()
{
 int x,y,t;
 long int g;
 
 scanf("%d %d",&sy,&sx);
 /*printf("s\n");*/
 
 for(y=0;y<sy;y++)
  {
  for(x=0;x<sx;x++)
   {
   poleused[y][x]=0;
   }
  } 
   
 for(y=0;y<sy;y++)
  {
  scanf("%s\n",pole[y]);
  } 
 
 /*for(y=0;y<sy;y++)
  {
  for(x=0;x<sx;x++)
   {
   printf("%d:",pole[y][x]);
   }
  printf("\n"); 
  }*/
  
 scanf("%d",&wordcnt);
 for(t=0;t<wordcnt;t++)
  {
  scanf("%s\n",word[t]);
  wordlen[t]=strlen(word[t]);
  } 
 /*for(t=0;t<wordcnt;t++)
  {
  printf("%s\n",word[t]);
  }*/ 

 /*printf("c\n");*/
 for(g=0;g<HASHSIZE;g++) bd[g]=9;
 /*getwordhashes();*/
 /*printf("h\n");*/
 gethashes(); 
 /*printf("w\n");*/
 getwordhashes();
 /*printf("e\n");*/
 /*process();*/
 printresult();
}

void getrandnums()
{
 int t;
 
 for(t=0;t<256;t++) {rands[t]=rand();/*printf("%8X ",rands[t]);*/}
}

int main()
{
 int t,z;
 
 scanf("%d\n",&z);
 bl=malloc(HASHSIZE*2);
 bx=malloc(HASHSIZE);
 by=malloc(HASHSIZE);
 bd=malloc(HASHSIZE);
 bs=malloc(HASHSIZE);
 if(!(bl&&bx&&by&&bd&&bs)) {printf("Blabla"); return 0;}

 getrandnums(); 
 for(t=0;t<z;t++)
  solve();
  
 return 0; 
}